<?php
	class paykeeperPayment extends payment {
		public function validate() { return true; }

        /** @inheritDoc */
        public static function getOrderId() {
            return (int) getRequest('orderid');
        }

		public function process($template = null) {
		        $order = $this->order;

			$order->order();

			$the_phone	= '';//phone is not specified by default
			$the_clientid	= $order->getCustomerId();
			$the_sum	= number_format($order->getActualPrice(), 2, '.', '');			
			$the_orderid	= $order->getId();

			$url = $this->object->payment_form_url;

                        $formdata = array(
                        "phone" 	=> $the_phone,
                        "clientid"	=> $the_clientid,
                        "sum"		=> $the_sum,
                        "orderid"	=> $the_orderid
                        );

                        //build the post string
                        $poststring = "";
                        foreach($formdata AS $key => $val){
                            $poststring .= urlencode($key) . "=" . urlencode($val) . "&";
                        }
                        // strip off trailing ampersand
                        $poststring = substr($poststring, 0, -1);

                        if(function_exists( "curl_init" )) {
                            $CR = curl_init();
                            curl_setopt($CR, CURLOPT_URL, $url);
                            curl_setopt($CR, CURLOPT_POST, 1);
                            curl_setopt($CR, CURLOPT_FAILONERROR, true); 
                            curl_setopt($CR, CURLOPT_POSTFIELDS, $poststring);
                            curl_setopt($CR, CURLOPT_RETURNTRANSFER, 1);
                             
                            curl_setopt($CR, CURLOPT_SSL_VERIFYPEER, 0);
                            
                            $the_payment_form = curl_exec( $CR );
                            
                            $the_error = curl_error( $CR );
                            if($the_error)
                              $the_payment_form = $the_error;

                            curl_close( $CR );
                        } else{
			      $options = array("http"=>array(
			      		"method"=>"POST",
					"header"=>"Content-type: application/x-www-form-urlencoded",
					"content"=>$poststring
					));
			      $context = stream_context_create($options);
			      $the_payment_form = file_get_contents($url, FALSE, $context);
			      if ($the_payment_form == NULL)
			        $the_payment_form = "error: curl_init doesn't exist";
                        }

			$param = array();
			$param['payment_form'] = $the_payment_form;

			$this->order->setPaymentStatus('initialized');
			list($templateString) = def_module::loadTemplates("emarket/payment/paykeeper/".$template, "form_block");

			$ret_value = def_module::parseTemplate($templateString, $param);

			return $ret_value;
		}

		public function poll() {
                  $the_Id	=  getRequest('id');
                  $the_Sum	=  getRequest('sum');
                  $the_Clientid	=  getRequest('clientid');
                  $the_Orderid	=  intval(getRequest('orderid'));
                  $the_Key	=  getRequest('key');


                  $our_key = $this->object->secret_key;

                  $our_signature = md5($the_Id . number_format((float)$the_Sum, 2, '.', '') . $the_Clientid . $the_Orderid . $our_key);

                      // check transaction signature
                  if($the_Key != $our_signature)
                    die('Message digest incorrect');

                    //change order status
                  $this->order->setPaymentStatus('accepted');
                  $this->order->payment_document_num = $the_Id;

                  $our_hash = md5($the_Id . $our_key);

                  die("OK $our_hash");
		}//public function poll() 
	};
?>
